/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of record.xs. Do not edit this file, edit record.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "record.xs"
/***************************************************************************
 *   X11::GUITest::record                                                  *
 *                                                                         *
 *   Copyright (C) 2007 by Marc Koderer / ecos GmbH                        *
 *   mkoderer@cpan.org                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
Code based on xneelib Version 2.06 is marked with [xneelib].
It is modified under terms of GPLv2
*/


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "datastructure.h"
#include "record.h"
#include <stdio.h>
#include <stdlib.h>



static Display *dpy = NULL;

/* To set DEBUG call SetRecordDEBUG */
static int DEBUG = 0;


static XRecordRange* range;
static XRecordRange* first_range;
static int num_ranges = 0;


static XRecordRange** ranges=NULL;
static XRecordContext context=0;

static int reply_counter = 0;

/*
init_range_defaults

- Setting up first range with default values
*/

void init_range_defaults()
    {
    first_range  = XRecordAllocRange();
    
    memset (first_range, 0, sizeof(XRecordRange));

    /*Default settings (dont need them) */

    
    /*
    first_range->delivered_events.first       = 0;
    first_range->delivered_events.last        = 0;
    first_range->core_requests.first          = 0;
    first_range->core_requests.last           = 0;
    first_range->errors.first                 = 0;
    first_range->errors.last                  = 0;
    first_range->core_replies.first           = 0;
    first_range->core_replies.last            = 0;
    first_range->ext_requests.ext_major.first = 0;
    first_range->ext_requests.ext_major.last  = 0;
    first_range->ext_requests.ext_minor.first = 0;
    first_range->ext_requests.ext_minor.last  = 0;
    first_range->ext_replies.ext_major.first  = 0;
    first_range->ext_replies.ext_major.last   = 0;
    first_range->ext_replies.ext_minor.first  = 0;
    first_range->ext_replies.ext_minor.last   = 0;
    first_range->device_events.first          = 0;
    first_range->device_events.last           = 0;
    */

    /*[xneelib]*/
    ranges =(XRecordRange**) Xcalloc (1, sizeof(XRecordRange*));
    

    ranges[0] = first_range;
    
    range = first_range;
    
    }


/*
dispatch

- Is called if a record infomation is dispatched. It will call a perl callback function
  if type is usable.

in: - XPointer xd
    - InterceptedData *data
    
*/

void dispatch (XPointer xd,XRecordInterceptData *data )
    {
    int                  data_type = 0;
    XRecordDatum         *xrec_data ;
    char*                text_cpy;
    
    xrec_data = (XRecordDatum*) (data->data);
    
    if (DEBUG == 1){printf ("DBG: Dispatchcall\n");}
    
    if(data->data_len!=0)
    {
       data_type = (int) xrec_data->type;
    }
    
    
    switch(data->category)
    {
    case XRecordFromClient:
        /*---- Requests*/
        if (DEBUG == 1){printf ("DBG: XRecordFromClient (Request) data_type: %i request_type %s length %li\n", data_type,print_request(data_type),data->data_len);}
    
    
        if (data_type == X_CreateWindow || data_type == X_DestroyWindow) 
            {
            PerlCallback(data->category,
                         data_type,
			 data->server_time,
                         ((xCreateWindowReq*) data->data)->x,
                         ((xCreateWindowReq*) data->data)->y,
                         ((xCreateWindowReq*) data->data)->wid,0);
            break;
            }
        if (data_type == X_PolyText8) 
            {
            /* form Xproto.h : 
               length in 4 bytes quantities
               of whole request, including this header */   
            
            /*Some strings arent nulltermiated - so we have to copy it
            */
            if (!(text_cpy = (char *) malloc ( ((data->data_len*4)+1))))
               {
               printf ("X11::GUITest::record runs out of memory\n");
               exit (1);
               }
               
            memcpy( (void*) text_cpy, (void*) data->data, ((data->data_len*4)));
            
            text_cpy[data->data_len*4] = '\0';
            
            /*PolyText8 overhead is 18 Bytes */
            PerlCallbackText(data->category,
                            data_type,
			    data->server_time,
                            ((xPolyTextReq*) data->data)->x,
                            ((xPolyTextReq*) data->data)->y,
                            (char *)&text_cpy[18]);
            break;
            }
        else 
            {
            PerlCallback(data->category,
                         data_type,data->server_time,0,0,0,0);
            }
                            
      break;
    case XRecordFromServer:
        /*----- Events */
        if (data_type == MotionNotify)
            {
            PerlCallback(data->category,
                         data_type,
			 data->server_time,
                         xrec_data->event.u.keyButtonPointer.rootX, 
                         xrec_data->event.u.keyButtonPointer.rootY,
                         xrec_data->event.u.keyButtonPointer.child,
                         xrec_data->event.u.keyButtonPointer.root);

            break;
               
           }
    if (data_type == KeyPress || data_type == KeyRelease ||
        data_type == ButtonPress || data_type == ButtonRelease)
        {
        PerlCallbackKey(data->category,
                        data_type,
			data->server_time,
                        0,
                        0,
                        xrec_data->event.u.u.detail);
        
        break;
       }
      else 
         {
         PerlCallback(data->category,
                      data_type,data->server_time,0,0,0,0);
         }
    break;
    case XRecordClientStarted:
      if (DEBUG == 1){printf ("DBG: Client started \n");}
      break;
    case XRecordClientDied:
      if (DEBUG == 1){printf ("DBG: Client died \n");}
      break;
    case XRecordStartOfData:
      if (DEBUG == 1){ printf ("DBG: Start of data\n");}
      break;
    case XRecordEndOfData:
      if (DEBUG == 1){printf ("DBG: End of data\n");}
      break;
    default:
      if (DEBUG == 1){printf ("DBG: Warning: unknown category type: %i \n",data->category);}
      break;
    }
    XRecordFreeData(data);
    }



/*Perl callback funtions*/


/*
PerlCallback

- PerlCallback function for all requests like X_CreateWindow etc.

    
*/

void PerlCallback (int cat, int type, unsigned int time ,int x, int y, long WinID, long PWinID)
    {
    dSP ;
    reply_counter++;

    ENTER ;
    SAVETMPS ;

    PUSHMARK(SP) ;
    
    XPUSHs(sv_2mortal(newSViv(cat)));
    XPUSHs(sv_2mortal(newSViv(type)));
    mXPUSHu(time);
    XPUSHs(sv_2mortal(newSViv(x)));
    XPUSHs(sv_2mortal(newSViv(y)));
    XPUSHs(sv_2mortal(newSViv(WinID)));
    XPUSHs(sv_2mortal(newSViv(PWinID)));
    PUTBACK ;
    
    if (DEBUG == 1){printf ("DBG: Call of PerlCallback Category: %d, Type %d, Time %u: X %d, Y %d, WinID %ld, PWinID %ld\n",
                            cat, type, time, x, y, WinID, PWinID);}
    
    call_pv("X11::GUITest::record::Callback", G_DISCARD);

    FREETMPS ;
    LEAVE ;
    }


/*
PerlCallbackText

- PerlCallback function for X_PolyText8

    
*/


void PerlCallbackText (int cat, int type, unsigned int time ,int x, int y, char* data)
    {
    dSP ;
    reply_counter++;

    ENTER ;
    SAVETMPS ;

    PUSHMARK(SP) ;
    
    XPUSHs(sv_2mortal(newSViv(cat)));
    XPUSHs(sv_2mortal(newSViv(type)));
    mXPUSHu(time);
    XPUSHs(sv_2mortal(newSViv(x)));
    XPUSHs(sv_2mortal(newSViv(y)));
    XPUSHs(sv_2mortal(newSVpv(data, 0)));
    PUTBACK ;
    
    if (DEBUG == 1){printf ("DBG: Call of PerlCallbackText Category: %d, Type %d, Time %u:  X %d, Y %d, Data %s\n",
                            cat, type, time, x, y, data);}
    
    call_pv("X11::GUITest::record::Callback", G_DISCARD);

    FREETMPS ;
    LEAVE ;
    }
    
/*
PerlCallbackText

- PerlCallback function for KeyPress and KeyRelease event

    
*/

void PerlCallbackKey (int cat, int type, unsigned int time, int x, int y, long key)
    {
    dSP ;
    reply_counter++;

    ENTER ;
    SAVETMPS ;

    PUSHMARK(SP) ;
    
    XPUSHs(sv_2mortal(newSViv(cat)));
    XPUSHs(sv_2mortal(newSViv(type)));
    mXPUSHu(time);
    XPUSHs(sv_2mortal(newSViv(x)));
    XPUSHs(sv_2mortal(newSViv(y)));
    XPUSHs(sv_2mortal(newSViv(key)));
    PUTBACK ;
    
    if (DEBUG == 1){printf ("DBG: Call of PerlCallbackKey Category: %d, Type %d, Time %u: X %d, Y %d, Key %ld\n",
                            cat, type, time, x, y, key);}
    
    call_pv("X11::GUITest::record::Callback", G_DISCARD);

    FREETMPS ;
    LEAVE ;
    }


static int SetupXDisplay(void)
    {

    /* Get Display Pointer */
    dpy = XOpenDisplay(NULL);
    if (dpy == NULL) { croak ("Not able to open Display");
                       return -1;
                     } 
    return 0;
    
    }


static int UnSetupXDisplay(void)
    {
    if (dpy != NULL) 
       {
       return XCloseDisplay(dpy);
       }
    return 0;

    }


/*
InternalDisableRecordContext

- Disables the record context:
        - It will dispatch all open information to Perl
        - It will close the context
        - It will free the memory of the ranges 

    
*/

static int InternalDisableRecordContext(void)
    {
    Display* new;
    int x;
    int reply_counter_last = 0;


    if (context != 0)
      {
        if (DEBUG == 1) {printf ("DBG: Disabling context %li\n",context);}
    
        /*Dispatch all infos */
        reply_counter = 0;
        while (1)
            {
            /* perlcallback  function increments the reply_counter variable */
            XRecordProcessReplies (dpy);
            /* No change --> no data for perl*/
            if (reply_counter_last == reply_counter ) {break;}
            reply_counter_last = reply_counter;
            }
        
        /* Special thanks to _Joel Dice_ for the input.
           Create a new display context to disable
           the old one
        */
        
        new = XOpenDisplay (NULL);
    
        XRecordDisableContext(new,context);
        XRecordFreeContext(new,context);	 
        XCloseDisplay(new);
        context = 0;
        
        

      }
    if(ranges != NULL)
        {
        if (DEBUG == 1) {printf ("DBG: Freeing %d ranges\n",num_ranges);}
        for (x=num_ranges; x >= 0; x--)
            {
            XFree(ranges[x]);
 	    ranges[x] = NULL;
            }

        XFree(ranges);
        ranges = NULL;
        }
    
    num_ranges = 0;
    
    init_range_defaults();

    return 0;
    }



#line 453 "record.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 597 "record.c"

XS_EUPXS(XS_X11__GUITest__record_QueryVersion); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_QueryVersion)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	char *	RETVAL;
	dXSTARG;
#line 459 "record.xs"
    int maj,min,ret;

    char version[23];
    ret = XRecordQueryVersion(dpy,&maj,&min);
    if (ret == 0)
        {
        if (DEBUG == 1) {printf ("QueryVersion failed\nRecord extension is not enabled on X-Server\n");}
        RETVAL = NULL;
        return;
        }
    sprintf(version,"%d.%d",maj,min);

    RETVAL = version;
#line 622 "record.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest__record_InitRecordData); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_InitRecordData)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 479 "record.xs"
    init_range_defaults();
#line 638 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_InitDisplay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_InitDisplay)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 485 "record.xs"
    RETVAL = SetupXDisplay();
#line 655 "record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest__record_DeInitRecordData); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_DeInitRecordData)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 493 "record.xs"
    int x;
     if(ranges != NULL)
        {
        if (DEBUG == 1) {printf ("DBG: Freeing %d ranges\n",num_ranges);}
        for (x=num_ranges; x >= 0; x--)
            {
            XFree(ranges[x]);
 	    ranges[x] = NULL;
            }

        XFree(ranges);
        ranges = NULL;
        }
#line 683 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_DeInitDisplay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_DeInitDisplay)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 511 "record.xs"
    if (DEBUG == 1){printf ("DBG: Unset Display\n");}
    RETVAL = UnSetupXDisplay();
#line 701 "record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest__record_EnableRecordContext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_EnableRecordContext)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 532 "record.xs"
    int datum_flags;
    XRecordClientSpec spec = XRecordAllClients;
    XPointer xd=NULL;
    void (*Pointer_func)(XPointer xd,XRecordInterceptData *data);
    Pointer_func = dispatch;
    datum_flags = XRecordFromServerTime | XRecordFromClientTime | XRecordFromClientSequence;

    // [xneelib]
    (void)XSynchronize(dpy, True);

    if(context != 0)
        {
        InternalDisableRecordContext();
        }
    if(ranges == NULL)
        {
        init_range_defaults();
        }

    if (DEBUG == 1) {printf ("DBG: Create context with range size: %d \n",num_ranges);}

    context = XRecordCreateContext(dpy,datum_flags,&spec, 1,ranges,num_ranges+1);
    if (DEBUG == 1) {printf ("DBG: Enabling context %li \n",context);}
    RETVAL = (int) XRecordEnableContextAsync(dpy,context,Pointer_func,xd);
#line 742 "record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest__record_CDisableRecordContext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_CDisableRecordContext)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 563 "record.xs"
    RETVAL = InternalDisableRecordContext();
#line 760 "record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest__record_CGetRecordInfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_CGetRecordInfo)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 571 "record.xs"
    reply_counter=0;	
    XRecordProcessReplies (dpy);
    if (reply_counter!=0) { RETVAL = 1;}
    else { RETVAL = 0;}
#line 781 "record.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest__record_AddRecordRange); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_AddRecordRange)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 598 "record.xs"
    num_ranges++;
    if (DEBUG == 1) {printf ("DBG: Add new range %d\n",num_ranges);}
    ranges = (XRecordRange**) Xrealloc (ranges, (num_ranges+1)*sizeof(XRecordRange*));
    range  = XRecordAllocRange();
    memset (range, 0, sizeof(XRecordRange));
    ranges[num_ranges]=range;
#line 802 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetDeliveredEvents); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetDeliveredEvents)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 620 "record.xs"
    range->delivered_events.first=first;
    range->delivered_events.last=last;
#line 822 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetCoreRequests); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetCoreRequests)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 638 "record.xs"
    range->core_requests.first = first;
    range->core_requests.last  = last;
#line 842 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetDeviceEvents); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetDeviceEvents)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 657 "record.xs"
    range->device_events.first = first;
    range->device_events.last  = last;
#line 862 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetErrors); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetErrors)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 677 "record.xs"
    range->errors.first = first;
    range->errors.last  = last;
#line 882 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetCoreReplies); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetCoreReplies)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 695 "record.xs"
    range->core_replies.first = first;
    range->core_replies.last  = last;
#line 902 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetExtRequestsMajor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetExtRequestsMajor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 713 "record.xs"
    range->ext_requests.ext_major.first = first;
    range->ext_requests.ext_major.last  = last;
#line 922 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetExtRequestsMinor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetExtRequestsMinor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 731 "record.xs"
    range->ext_requests.ext_minor.first = first;
    range->ext_requests.ext_minor.last  = last;
#line 942 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetExtRepliesMajor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetExtRepliesMajor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 749 "record.xs"
    range->ext_replies.ext_major.first  = first;
    range->ext_replies.ext_major.last   = last;
#line 962 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_SetExtRepliesMinor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_SetExtRepliesMinor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "first, last");
    {
	int	first = (int)SvIV(ST(0))
;
	int	last = (int)SvIV(ST(1))
;
#line 767 "record.xs"
    range->ext_replies.ext_minor.first = first;
    range->ext_replies.ext_minor.last  = last;
#line 982 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_CSetDEBUG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_CSetDEBUG)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "level");
    {
	int	level = (int)SvIV(ST(0))
;
#line 775 "record.xs"
    printf("DBG: Set Debug to %i\n",level);
    DEBUG = level;
#line 1000 "record.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_X11__GUITest__record_ConvRequest2Text); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_ConvRequest2Text)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "type");
    {
	int	type = (int)SvIV(ST(0))
;
	char *	RETVAL;
	dXSTARG;
#line 782 "record.xs"
    RETVAL = print_request(type);
#line 1019 "record.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest__record_ConvEvent2Text); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest__record_ConvEvent2Text)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "type");
    {
	int	type = (int)SvIV(ST(0))
;
	char *	RETVAL;
	dXSTARG;
#line 790 "record.xs"
    RETVAL = print_event(type);
#line 1039 "record.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_X11__GUITest__record); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_X11__GUITest__record)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("X11::GUITest::record::QueryVersion", XS_X11__GUITest__record_QueryVersion);
        newXS_deffile("X11::GUITest::record::InitRecordData", XS_X11__GUITest__record_InitRecordData);
        newXS_deffile("X11::GUITest::record::InitDisplay", XS_X11__GUITest__record_InitDisplay);
        newXS_deffile("X11::GUITest::record::DeInitRecordData", XS_X11__GUITest__record_DeInitRecordData);
        newXS_deffile("X11::GUITest::record::DeInitDisplay", XS_X11__GUITest__record_DeInitDisplay);
        newXS_deffile("X11::GUITest::record::EnableRecordContext", XS_X11__GUITest__record_EnableRecordContext);
        newXS_deffile("X11::GUITest::record::CDisableRecordContext", XS_X11__GUITest__record_CDisableRecordContext);
        newXS_deffile("X11::GUITest::record::CGetRecordInfo", XS_X11__GUITest__record_CGetRecordInfo);
        newXS_deffile("X11::GUITest::record::AddRecordRange", XS_X11__GUITest__record_AddRecordRange);
        newXS_deffile("X11::GUITest::record::SetDeliveredEvents", XS_X11__GUITest__record_SetDeliveredEvents);
        newXS_deffile("X11::GUITest::record::SetCoreRequests", XS_X11__GUITest__record_SetCoreRequests);
        newXS_deffile("X11::GUITest::record::SetDeviceEvents", XS_X11__GUITest__record_SetDeviceEvents);
        newXS_deffile("X11::GUITest::record::SetErrors", XS_X11__GUITest__record_SetErrors);
        newXS_deffile("X11::GUITest::record::SetCoreReplies", XS_X11__GUITest__record_SetCoreReplies);
        newXS_deffile("X11::GUITest::record::SetExtRequestsMajor", XS_X11__GUITest__record_SetExtRequestsMajor);
        newXS_deffile("X11::GUITest::record::SetExtRequestsMinor", XS_X11__GUITest__record_SetExtRequestsMinor);
        newXS_deffile("X11::GUITest::record::SetExtRepliesMajor", XS_X11__GUITest__record_SetExtRepliesMajor);
        newXS_deffile("X11::GUITest::record::SetExtRepliesMinor", XS_X11__GUITest__record_SetExtRepliesMinor);
        newXS_deffile("X11::GUITest::record::CSetDEBUG", XS_X11__GUITest__record_CSetDEBUG);
        newXS_deffile("X11::GUITest::record::ConvRequest2Text", XS_X11__GUITest__record_ConvRequest2Text);
        newXS_deffile("X11::GUITest::record::ConvEvent2Text", XS_X11__GUITest__record_ConvEvent2Text);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

